from sys import stdin
from math import log

ls=stdin.readlines()
freqs = map(lambda x: map(lambda y: float(y), x.split(' ')[1:]), ls)
gens = len(freqs[0])
haplos = len(freqs)

def dist(h1, h2, haplos):
    maxDist = int(log(haplos, 2))
    d = maxDist
    for i in range(maxDist):
        if not((2**i & h1) ^ (2**i & h2)):
            d -= 1
    return d

def get_mut_freqs(freqs, gen, haplos, num_loci):
    mut_freqs = [0.0]*num_loci
    for i in range(haplos):
        freq = freqs[gen][i]
        for locus in range(num_loci):
            if 2**locus & i != 0:
                mut_freqs[locus] += freq
    return mut_freqs

def calcVo(freqs, gen, haplos, num_loci):
    vo = 0.0
    mean_diff = 0.0
    for h1 in range(haplos): 
        for h2 in range(haplos): 
            mean_diff += freqs[gen][h1]*freqs[gen][h2]*dist(h1,h2,haplos)
    print "md", mean_diff
    sf = 0
    for h1 in range(haplos): 
        for h2 in range(haplos): 
            print h1,h2,dist(h1,h2, haplos)
            sf += freqs[gen][h1]*freqs[gen][h2]
            vo += freqs[gen][h1]*freqs[gen][h2]*(dist(h1,h2, haplos)-mean_diff)**2
    print "sf", sf
    return vo
    
def getExpFreq(haplo, mut_freqs):
    ps = []
    for i in range(len(mut_freqs)):
        if haplo & 2**i > 0:
            has_mut = True
        else:
            has_mut = False
        if has_mut:
            p = mut_freqs[i]
        else:
            p = 1 - mut_freqs[i]
        ps.append(p)
    return reduce(lambda x,y:x*y, ps)


def calcVe(freqs, gen, haplos, num_loci):
    mut_freqs = get_mut_freqs(freqs, gen, haplos, num_loci)
    ve = 0.0
    for locus in range(num_loci):
        h = 2*mut_freqs[locus]*(1-mut_freqs[locus])
        ve += h*(1-h)
    return ve

#ve = calcVe([[0.5,0.0,0.0,0.5]], 0, 4, 2)
ve = calcVe([[0.25,0.25,0.25,0.25]], 0, 4, 2)
#vo = calcVo([[0.25,0.25,0.25,0.25]], 0, 4, 2)
vo = calcVo([[0.5,0,0,0.5]], 0, 4, 2)
#vo = calcVo([[0,0.5,0.5,0]], 0, 4, 2)
print vo, ve, (vo/ve) - 1.0

#for i in range(16):
#    for j in range(16):
#        print i, j, dist(i,j,16)
