from pylab import *
from sys import argv, exit

if len(argv) != 4:
    print "Parameters: <s1> <s2> <dFreq>"
    exit (-1)

s1 = argv[1]
s2 = argv[2]
dFreq = argv[3]
cms = ['1', '2', '4']
colors = {'1':'r', '2':'g', '4':'b'}

sp1 = s1[0]+'.'+s1[1:]
sp2 = s2[0]+'.'+s2[1:]
dfp = dFreq[0]+'.'+dFreq[1:]
suptitle('Frequency of sensitive parasites', fontsize=14)
title('fitness penalties='+sp1+', ' + sp2+' and drug rate='+dfp)
maxLength = 1000
results = {}

def doFile(fName, results, s, dot, maxLength):
    f = open(fName)
    l = f.readline()
    while l<>'':
        toks = l.rstrip().split(' ')
        haplo = toks[0]
        if haplo == "SS":
            freqGen = {}
            currFreq = float(toks[1])
            allFreqs = [currFreq]
            speed = []
            freqs = map(lambda x: float(x), toks[2:])
            allFreqs.extend(freqs)
            for freq in freqs:
                speed.append(freq/currFreq)
                currFreq = freq
            #results['speed ' + cm + s] = colors[cm], speed
            results['MOI ' + cm  + ', s ' + s] = colors[cm] + dot, allFreqs
            if len(allFreqs)< maxLength: maxLength = len(allFreqs)
            #plot(speed, colors[cm], label='MOI ' + cm)
            #plot(allFreqs, colors[cm]+'.' , label='freq SS ' + cm)
        l = f.readline()
    f.close()
    return maxLength

for cm in cms:
    maxLength = doFile('cm' + cm + '/freqsMFT-21-' + cm + '+' + s1 + '+' + dFreq + '.txt', results, sp1, '', maxLength)
    maxLength = doFile('cm' + cm + '/freqsMFT-21-' + cm + '+' + s2 + '+' + dFreq + '.txt', results, sp2, '.', maxLength)

lgds = results.keys()
lgds.sort()
for lgd in lgds:
    cl,lst = results[lgd]
    plot(lst[:(maxLength-1)], cl, label = lgd)
axes().set_xlabel('Generations')
axes().set_ylabel('frequency')
legend()
show()


