from pylab import *
from sys import argv, exit

if len(argv) != 3:
    print "Parameters: <projDir> <s> <dFreq> <epi>"
    exit (-1)

s = argv[1]
dFreq = argv[2]
cms = ['1', '2', '4']
colors = {'1':'r', '2':'g', '4':'b'}

sp = s[0]+'.'+s[1:]
dfp = dFreq[0]+'.'+dFreq[1:]
suptitle('Speed of change', fontsize=14)
title('fitness penalty='+sp+' and drug frequency='+dfp)

def getFreqs(f):
    l = f.readline()
    while l != '':
        toks = l.rstrip().split(' ')
        haplo = toks[0]
        if haplo == "SS":
            s = map(lambda x: float(x), toks[1:])
        elif haplo == "RR":
            mr = map(lambda x: float(x), toks[1:])
        l = f.readline()
    return s, mr

for cm in cms:
    f = open('cm' + cm + '/freqsMFT-21-' + cm + '+' + s + '+' + dFreq + '.txt')
    sMFT, mrMFT = getFreqs(f)
    f.close()
    f = open('cm' + cm + '/freqsThresRot-21-' + cm + '+' + s + '+' + dFreq + '.txt')
    sTR, mrTR = getFreqs(f)
    f.close()
    plot(mrMFT, sMFT, colors[cm] + '.', label = cm + ' MFT')
    plot(mrTR, sTR, colors[cm] + '^', label = cm + ' Rot')
axes().set_xlabel('Multiple-resistant frequency')
axes().set_ylabel('Sensitive frequency')
legend()
show()


