from pylab import *
from sys import argv, exit, stdin

if len(argv)<2:
    print "Arguments: <title and file>+"
    exit(-1)

fNames = []
titles = []
for it in range(1,len(argv)):
    if it % 2 == 1:
        titles.append(argv[it])
    else:
        fNames.append(argv[it])

def processTriple(f):
    f.readline()
    s = []
    df = []
    try:
        s = map(lambda x:float(x),f.readline().rstrip().split(' '))
        df = map(lambda x:float(x),f.readline().rstrip().split(' '))
    except ValueError:
        f.readline() # We need to read the next line
    return s, df

suptitle('Simulation outcome', fontsize=14)
plt = 1
for fi in range(len(fNames)):
    print len(fNames)/2 , plt
    ax = subplot(2, len(fNames)/2, plt)
    plt += 1
    f = open(fNames[fi])
    sS, dfS = processTriple(f)
    sM, dfM = processTriple(f)
    sM2, dfM2 = processTriple(f)
    sM.extend(sM2)
    dfM.extend(dfM2)
    sR, dfR = processTriple(f)
    sR2, dfR2 = processTriple(f)
    sR.extend(sR2)
    dfR.extend(dfR2)
    if len(sR)>0:
        scatter(dfR, sR, edgecolors='none', s=10, c=['#ff0000']*len(sR), label='Resistant fixates')
    if len(sM)>0:
        scatter(dfM, sM, edgecolors='none', s=10, c=['#ffff00']*len(sM), label='Intermediate')
    if len(sS)>0:
        scatter(dfS, sS, edgecolors='none', s=10, c=['#00FF00']*len(sS), label='Sensitive fixates')
    f.close()
    ax.set_ylabel("Fitness penalty")
    if fi==len(fNames)-1: ax.set_xlabel('Drug usage')
    title(titles[fi])
    axis([0,1,0,1])
   
#axes().set_ylabel('Generations')
#axes().set_xlabel('Drop in sensitive frequency')
#legend()
show()
