package malaria

int GENS = 500
Simulation sim
String writeDir

if (args.size()!=1) {
    println "Argument: persistence_dir"
    System.exit(-1)
}
else {
    writeDir = args[0]
}


Persistence writer = new Persistence(writeDir)
sim = new Simulation(GENS, writer)

HashMap<Integer, Double> cm7 = TypicalScenarios.typicalClonal
HashMap<Integer, Double> cm21 = TypicalScenarios.oneTwoClonal
HashMap<Integer, Double> cm2 = TypicalScenarios.twoClonal


List<Double> Ss = TypicalScenarios.evenS
List<Double> dFreqs = TypicalScenarios.evenDFreqs

List<Double> resLevels = [0D, 0.25D]

workMults= [
    [1:1D], [2:1D], [3:1D], [4:1D], [5:1D], [6:1D],
    [7:1D], [8:1D],  [9:1D],  [10:1D],  /*[20:1D]*/ ]
workMults = [cm7, cm21, cm2]

double[] d2 = [0.125D, 0.125D]
sim.doThresRot(2, 0.1D, 0.8D, cm7, 1, d2, 0)
sim.doMFT(2, 0.1D, 0.8D, cm7, 1, d2)
chart = Chart.plotCase("bla" ,
    sim.results.values().toArray()[0], [[0],[1]])
//Chart.doChart(chart)
int[][] mutMuts =  [[],[0],[1],[0,1]]
mutMuts = [[],[0],[1],[0,1]]
chart2 = Chart.plotSingleS(sim.results.values().toArray()[0], mutMuts)
//Chart.doChart(chart2)

Table t = new Table(System.out)

println t.reportDuration(GENS, sim,
        [[0],[1]], 0.1D, [0])
/*
int numCases = 0
for (clonalMults in workMults) {
for (s in Ss) {
    for (dFreq in dFreqs) {
        for (resLevel in resLevels) {
            //if (resLevel+dFreq>=1) continue
            numCases ++
            //sim.doMFT(1, s, dFreq, clonalMults, 1)
            //sim.doMFT(1, s, dFreq, clonalMults, 2)

            sim.doMFT(2, s, dFreq, clonalMults, 1)
            sim.doThresRot(2, s, dFreq, clonalMults, 1)
            sim.doThresRotFixed(2, s, dFreq, clonalMults, 1)
            sim.doMFT(2, s, dFreq, clonalMults, 2)
            sim.doThresRot(2, s, dFreq, clonalMults, 2)
            //sim.doThresRotFixed(2, s, dFreq, clonalMults, 2)

            sim.doMFT(3, s, dFreq, clonalMults, 1)
            sim.doThresRot(3, s, dFreq, clonalMults, 1)
            //sim.doThresRotFixed(3, s, dFreq, clonalMults, 1)
            //results[["Triple", s, dFreq]] = sim.doMFT(3, s, dFreq, clonalMults, 2)
            //results[["TripleThresRot", s, dFreq]] = sim.doThresRot(3, s, dFreq, clonalMults, 2)
            //sim.doThresRotFixed(3, s, dFreq, clonalMults, 2)
        }
    }
}
}

println numCases

Table table = new Table(System.out)

def compareCMs = {Simulation sims, drugMuts ->
    for (CM in workMults) {
        println "  CM " + CM
        Simulation cmSim = sims.getSimCM(CM)
        println "  " + table.countWinner(GENS, cmSim, drugMuts, 0.1D, [2,1,0], "MFT", "ThresRot")
        println "    dFreq"
        for (dFreq in [0.0D, 0.1D, 0.2D, 0.3D, 0.4D, 0.5D, 0.6D]) {
            Simulation cmDSim = cmSim.getSimDrugFreq(dFreq,dFreq)
            println "    " + dFreq + " "  + table.countWinner(GENS, cmDSim, drugMuts, 0.1D, [2,1,0], "MFT", "ThresRot")            
            //if (dFreq==0.0D) println table.dumpDuration(GENS, cmDSim, drugMuts, 0.1D, [2,1,0])
        }
        println "    s"
        for (s in [0.0D, 0.1D, 0.2D, 0.3D, 0.4D, 0.5D]) {
            Simulation cmSSim = cmSim.getSimS(s, s)
            println "    " + s + " "  + table.countWinner(GENS, cmSSim, drugMuts, 0.1D, [2,1,0], "MFT", "ThresRot")
            //if (dFreq==0.0D) println table.dumpDuration(GENS, cmDSim, drugMuts, 0.1D, [2,1,0])
        }
        //println table.dumpWinner(GENS, cmSim, drugMuts, 0.1D, [2,1,0], "MFT", "ThresRot")
    }
}

//table.dumpDuration(GENS, sim, [[0],[1]], 0.1, [2,1,0])
//table.dumpDuration(GENS, sim, [[0,1],[2,3]], 0.1D, [2,1,0])
//table.dumpWinner(GENS, sim, [[0,1],[2,3]], 0.1D, [2,1,0], "MFT", "ThresRot")

Simulation d2 = sim.getSimNumDrugs(2)
Simulation d3 = sim.getSimNumDrugs(3)
Simulation d2_1 = d2.getSimLocDrug(1)
Simulation d2_2 = d2.getSimLocDrug(2)

//*
//println "2 drugs 1 locus"
//compareCMs(d2_1, [[0], [1]])
//println "2 drugs 2 loci"
//compareCMs(d2_2, [[0,1], [2,3]])
//println "3 drugs 1 locus"
//compareCMs(d3  , [[0], [1], [2]])

//println "2 drugs 1 locus, many CMs"
//compareCMs(d2_1, [[0], [1]])
*/