package malaria

int GENS = 1000
//double THRESHOLD = 0.3D
//double START_FREQ = 0.0003D
double THRESHOLD = 0.1D
double START_FREQ = 0.003D
boolean doTS = false
int numDrugs = 2
int locPerDrug = 1
Simulation sim
String writeDir

if (args.size()!=1) {
    println "Argument: persistence_dir"
    System.exit(-1)
}
else {
    writeDir = args[0]
}


Persistence writer = new Persistence(writeDir)
sim = new Simulation(GENS, writer, 0, START_FREQ, THRESHOLD, false)


List<Double> resLevels = [0.0D]
List<Double> Ss = TypicalScenarios.evenS
Ss = [0.3D]
List<Double> TSs = TypicalScenarios.mediumTS
TSs  = [0.0D]
List<Double> dFreqs = TypicalScenarios.massiveDFreqs

boolean isSI
isSI = false
List<HashMap<Integer,Double>> workMults = []
workMults= [
    [1:1D],
    [1:0.9D, 2:0.1D], [1:0.5D, 2:0.5D],
    [2:1D], [3:1D], //[4:1D], [5:1D], [6:1D], [7:1D], [8:1D],
    [9:1D],  [10:1D],  /*[20:1D]*/ ]
minInterval = 0

SimulationRunner sr = new SimulationRunner(sim,
    workMults, resLevels, TSs, Ss, dFreqs, isSI)
sr.runStandard(numDrugs, locPerDrug, minInterval)
Table table = new Table(System.out)

drugMuts = [[0],[1]]
int[] m0 = [0]
int[] m1 = [1]
for (namePost in [["LDCompareMFT.png", "MFT"], ["LDCompareThres.png", "Rot"]]) {
    Simulation mySim = sim.getSimPostfix(namePost[1])
    chart = Chart.plotLDAsFundamentalCM(
        GENS, THRESHOLD, (int[][])drugMuts.toArray(),
        mySim, false, doTS, true, m0, m1, workMults)
    out = new FileOutputStream(namePost[0])
    Chart.saveChart(out, chart)
    out.close()
}