/*
 * OGParser. Parses OG files.
 */

package malaria

/**
 *
 * @author tiago
 */
class OGParser {
    FileReader f
    Map <Integer, Map<Integer, Double>> gen
    Map <Integer, Map<Integer, Double>> clone

    public OGParser(FileReader f) {
        this.f = f
        parse()
    }

    public OGParser(String fName) {
        this(new FileReader(fName))
    }

    void parse() {
        gen = [:]
        clone = [:]
        int currGen = -1
        String line
        while ((line = f.readLine()) != null) {
            int currClone
            double freq
            String[] toks = line.split(" ")
            print toks
            currClone = Integer.parseInt(toks[0])
            freq = Double.parseDouble(toks[1])
            if (currClone == 0) {
                currGen ++
                gen[currGen] = [:]
            }
            if (currGen == 0) {
                clone[currClone] = [:]
            }
            gen[currGen][currClone] = freq
            clone[currClone][currGen] = freq
        }
    }

    Map <Integer, Double> getGen(int myGen) {
        return gen[myGen]
    }

    Map <Integer, Double> getClone(int myClone) {
        return clone[myClone]
    }

    int getGenClone(int myGen, int myClone) {
        return gen[myGen][myClone]
    }

    int getNumGens() {
        return gen.size()
    }

    int getNumClones() {
        return clone.size()
    }
	
}

