package malaria;

/**
 *
 * @author tra
 */

import java.io.*;

public class PolicyResult implements Serializable {
    double[][] genFreqs;
    int[] swapTimes = null;
    int[] usedDrugs = null;
    int mftGen;
    
    public PolicyResult(double[][] genFreqs) {
        this.genFreqs = genFreqs;
    }

    public PolicyResult(double[][] freqs, int[] swapTimes, int[] usedDrugs, int mftGen) {
       this(freqs);
       this.swapTimes = swapTimes;
       this.usedDrugs = usedDrugs;
       this.mftGen    = mftGen;
    }
    
    public String toString() {
        StringBuffer sb = new StringBuffer();
        int gen=0;
        for (double[] freqs : genFreqs ) {
            sb.append(gen +  " ");
            gen++;
            for (double freq : freqs) {
                sb.append(freq + " ");
            }
            sb.append("\n");
        }
        if (swapTimes != null) {
            for (int i=0; i<swapTimes.length; i++) {
                sb.append(usedDrugs[i]+"@"+swapTimes[i]+" ");
            }
            sb.append("\n");
        }
        return sb.toString();
    }

}
