package malaria

/**
 *
 * @author tra
 */
class ResultClassifier {
    HashMap<Integer, Double> cm
    int numDrugs
    double dFreq
    double s
    double ts
    boolean isSI
    int locDrug
    String policy
    double[] residualFreqs
    int minInterval
    
    public ResultClassifier(
        HashMap<Integer, Double> cm, int numDrugs,
        double dFreq, double s, double ts, boolean isSI,
        int locDrug, String policy,
        double[] residualFreqs, int minInterval) {
        this.cm            = cm
        this.numDrugs      = numDrugs
        this.dFreq         = dFreq
        this.s             = s
        this.ts            = ts
        this.isSI          = isSI
        this.locDrug       = locDrug
        this.policy        = policy
        this.residualFreqs = residualFreqs
        this.minInterval   = minInterval
    }

    public ResultClassifier(String desc) {
        String[] bits = desc.split("+")
        cm = stringToClonalMults(bits[0])
        numDrugs = Integer.parseInt(bits[1])
        dFreq = Double.parseDouble(bits[2])
        s = Double.parseDouble(bits[3])
        ts = Double.parseDouble(bits[4])
        isSI = Integer.parseInt(bits[5])==0 ? false : true
        locDrug = Integer.parseInt(bits[6])
        policy = bits[7]
        residualFreqs = stringToDoubleArray(bits[8])
    }

    public String toString() {
        String str
        str = clonalMultsToString()
        str += "+" + numDrugs + "+" + dFreq + "+" + s + "+" +
        ts + "+" + (isSI ? "1" : "0") + "+" +
        locDrug + "+" + policy + "+" + residualFreqs + "+" + minInterval
        return str
    }

    public String clonalMultsToString() {
        String part="";
        List<Integer> CMs = new ArrayList<Integer>(cm.keySet());
        java.util.Collections.sort(CMs);
        for (int CM : CMs) {
            part += CM + ":" + cm.get(CM);
            part += "=";
        }
        part = part.substring(0, part.length()-1);
        return part;
    }

    public boolean equals(Object obj) {
        if (!(obj instanceof malaria.ResultClassifier)) return false;
        return this.toString().equals(obj.toString())
    }

    public int hashCode() {
        return toString().hashCode()
    }

}
