package malaria

int GENS = 500
Simulation sim
String writeDir

if (args.size()!=3) {
    println "Argument: persistence_dir dFreq s"
    System.exit(-1)
}
else {
    writeDir = args[0]
    argDFreq = Double.parseDouble(args[1])
    argS = Double.parseDouble(args[2])
}


Persistence writer = new Persistence(writeDir)
sim = new Simulation(GENS, writer)

HashMap<Integer, Double> clonalMults = TypicalScenarios.typicalClonal


List<Double> Ss = [argS]
List<Double> dFreqs = [argDFreq]
for (s in Ss) {
    for (dFreq in dFreqs) {
        //sim.doMFT(1, s, dFreq, clonalMults, 1)
        //sim.doMFT(1, s, dFreq, clonalMults, 2)

        sim.doMFT(2, s, dFreq, clonalMults, 1)
        sim.doThresRot(2, s, dFreq, clonalMults, 1)
        sim.doThresRotFixed(2, s, dFreq, clonalMults, 1)
        //sim.doMFT(2, s, dFreq, clonalMults, 2)
        //sim.doThresRot(2, s, dFreq, clonalMults, 2)
        //sim.doThresRotFixed(2, s, dFreq, clonalMults, 2)

        //sim.doMFT(3, s, dFreq, clonalMults, 1)
        //sim.doThresRot(3, s, dFreq, clonalMults, 1)
        //sim.doThresRotFixed(3, s, dFreq, clonalMults, 1)
        //results[["Triple", s, dFreq]] = sim.doMFT(3, s, dFreq, clonalMults, 2)
        //results[["TripleThresRot", s, dFreq]] = sim.doThresRot(3, s, dFreq, clonalMults, 2)
        //sim.doThresRotFixed(3, s, dFreq, clonalMults, 2)
    }
}


for (policy in ["MFT", "ThresRot", "ThresRotFixed"]) {
    ResultClassifier rc = new ResultClassifier(clonalMults, 2, argDFreq, argS, 1, policy)
    Chart.plotCase(policy, sim.results[rc], [[0],[1]])
    println sim.results[rc].swapTimes
}
//Chart.plotS((String[])["Single drug"].toArray(), (PolicyResult[])[pr].toArray(), 1)