import os

def getGen(freqs, thres, epi, numDrugs = 2):
    if numDrugs ==2 :
        if epi == "FullEpistasis":
            for i in range(len(freqs[0])):
                if freqs[15][i]*2+freqs[3][i]+freqs[7][i]+freqs[11][i]+freqs[12][i]+freqs[13][i]+freqs[14][i]>thres*2:
                    return i
            return None
        elif epi == "Full+Asym":
            for i in range(len(freqs[0])):
                if freqs[15][i]*4+freqs[3][i]*2+freqs[7][i]*3+freqs[11][i]*2+freqs[12][i]*2+freqs[13][i]*3+freqs[14][i]*2+freqs[1][i]+freqs[5][i]*2+freqs[6][i]+freqs[9][i]>thres*4:
                    return i
            return None
    elif numDrugs == 3:
        if epi == "FullEpistasis":
            for i in range(len(freqs[0])):
                addUp = 0.0
                for locus in range(len(freqs)):
                    if (locus & 1) and (locus & 2):
                        addUp += freqs[locus][i]
                    if (locus & 4) and (locus & 8):
                        addUp += freqs[locus][i]
                    if (locus & 16) and (locus & 32):
                        addUp += freqs[locus][i]

                if addUp>thres*3:
                    return i
            return None

def readFreqs(f):
    l = f.readline()
    freqs = {}
    while l!="":
        hapl, freq = l.rstrip().split()
        hapl = int(hapl)
        freq = float(freq)
        freqs.setdefault(hapl, []).append(freq)
        l = f.readline()
    f.close()
    return freqs, max(freqs.keys())


def readSws(f):
    sws = []
    l = f.readline()
    while l != "":
        sws.append(tuple(map(lambda x: int(x),l.rstrip().split(" "))))
        l = f.readline()
    f.close()
    return sws

def dirTpl(numDrugs):
    return os.sep.join(["%s", str(numDrugs) + "%s%s%d"])
def fnameTpl(numDrugs):
    return os.sep.join([dirTpl(numDrugs), "%s-"+str(numDrugs)+"2+%s+%s.og"])
def fnameTplSw(numDrugs):
    return os.sep.join([dirTpl(numDrugs), "%s-"+str(numDrugs)+"2+%s+%s.sw"])
