import sys
import pylab
import os
import re
from Utils import *

#Number of drugs == 2

if len(sys.argv) != 3:
    print "Arguments: %s <projDir> <s>" % (sys.argv[0])
    sys.exit(-1)

projDir = sys.argv[1]
s = sys.argv[2]
numDrugs = 2


def getDFreqs(pol, epi, MOI, s):
    mySet = set()
    myRe = re.compile(".*\+%s+\+([0-9]+)\.og$" % (s))
    cases = os.listdir(dirTpl(2) % (projDir, pol, epi, MOI))
    for case in cases:
        match = myRe.match(case)
        if match:
            mySet.add(match.group(1))
    return mySet


def getGen4DFreq(pol, epi, MOI, s):
        dFreqs = getDFreqs(pol,epi,MOI,s)
        gens = {}
        for dFreq in dFreqs:
            if pol=="MFT":
                mftName = fnameTpl(2) %(projDir, "MFT", epi, MOI, "MFT", s, dFreq)
                mftFreqs, maxHaplo = readFreqs(open(mftName))
                gen = getGen(mftFreqs, 0.1, epi, numDrugs)
            else:
                rotName = fnameTpl(2) %(projDir, "Rot", epi, MOI, "ThresRot", s, dFreq)
                rotNameSw = fnameTplSw(2) %(projDir, "Rot", epi, MOI, "ThresRot", s, dFreq)
                rotFreqs, maxHaplo = readFreqs(open(rotName))
                sws = readSws(open(rotNameSw))
                if numDrugs==2:
                    if len(sws)>2:
                        gen = sws[2][0]
                    else:
                        gen=None
                elif numDrugs==3:
                    if len(sws)>3:
                        gen = sws[3][0]
                    else:
                        gen=None
            myS, myDFreq = float(s[0]+"."+s[1:]), float(dFreq[0]+"."+dFreq[1:])
            if not gen or gen==0 or myDFreq>0.6 or dFreq<0.2: continue


            gens[myDFreq]=gen

        dFreqs = gens.keys()
        dFreqs.sort()
        y = []
        for dFreq in dFreqs:
            y.append(gens[dFreq])
        return dFreqs, y


pylab.subplot(211)
pylab.title("Policy duration")

for pol in ["MFT", "Rot"]:
    epi = "FullEpistasis"
    for MOI in [2, 4]:
        dFreqs, y = getGen4DFreq(pol, epi, MOI, s)

        if MOI==2:
            marker="k+"
        else:
            marker = "k"
        if pol=="MFT":
            marker += "-"
        else:
            marker += "--"
        pylab.plot(dFreqs,y,marker,label="%s %s" % (pol, MOI))
pylab.legend()

pylab.subplot(212)
for pol in ["MFT", "Rot"]:
    for epi in ["FullEpistasis", "Full+Asym",]:
        MOI = 2
        dFreqs, y = getGen4DFreq(pol, epi, MOI, s)

        if epi=="FullEpistasis":
            marker="k+"
        else:
            marker = "k"
        if pol=="MFT":
            marker += "-"
        else:
            marker += "--"
        pylab.plot(dFreqs,y,marker,label="%s %s" % (pol, epi))
pylab.legend()


pylab.show()
