import pylab
import math
import os
import sys
from Utils import *

if len(sys.argv) != 5:
    print "Arguments: %s <projDir> <MOI> <s> <dfreq>" % (sys.argv[0])
    sys.exit(-1)

projDir = sys.argv[1]
MOI = sys.argv[2]
s = sys.argv[3]
dFreq = sys.argv[4]


def calcR(freqs, l1, l2):
    h = {}
    l = [[0.0, 0.0], [0.0, 0.0]]
    for fi in range(len(freqs)):
        hkey = ""
        for locus in [l1, l2]:
            if locus == l1:
                pos = 0
            else:
                pos = 1
            if fi & 2**locus > 0:
                hkey += "1"
                l[pos][1] += freqs[fi]
            else:
                hkey += "0"
                l[pos][0] += freqs[fi]
        h[hkey] = h.get(hkey,0) + freqs[fi]
    #print h["00"], 
    d = h["00"] - ((l[0][0]) * (l[1][0]))
    r = d / math.sqrt(l[0][0]*l[0][1]*l[1][0]*l[1][0])
    return r


def plotR(genFreqs, l1, l2, label):
    rs = []
    x = range(len(genFreqs[0]))
    for gen in range(len(genFreqs[0])):
        myFreqs = map(lambda x: genFreqs[x][gen], genFreqs.keys())
        rs.append(calcR(myFreqs, l1, l2))

    pylab.plot(x,rs,label=label)



first = True

def plotBoth(pos, freqs, plots, title, withLegend=True):
    global first
    ncolors = len(mftFreqs.keys()) + 0.0
    pylab.subplot(pos)
    pylab.title(title)

    for hpl in mftFreqs:
        c = (int(hpl))/ncolors
        pylab.plot(freqs[hpl], color=str(c))
    if first:
        pylab.ylabel("Frequency")
    pylab.subplot(pos+int(str(pos)[1]))
    for l1,l2, label in plots:
        plotR(freqs, l1, l2, label)
    if withLegend:
        pylab.legend()
    pylab.xlabel("Generations")
    if first:
        pylab.ylabel("LD(r)")
    first = False

mftFreqs, maxHaplo = readFreqs(open(
    os.sep.join([projDir,
                 "2MFTFullEpistasis"+MOI,
                 "MFT-22+%s+%s.og" % (s, dFreq) ])))
plotBoth(241, mftFreqs, [(0,1,"Same drug"),(0,2, "Different drug")], "MFT, Full epistasis", False)

rotFreqs, maxHaplo = readFreqs(open(
    os.sep.join([projDir,
                 "2RotFullEpistasis"+MOI,
                 "ThresRot-22+%s+%s.og" % (s, dFreq) ])))
plotBoth(242, rotFreqs, [(0,1,"Same drug"),(0,2, "Different drug")], "Rotation, Full epistasis")


#mftFreqs, maxHaplo = readFreqs(open(
#    os.sep.join([projDir,
#                 "2MFTFull+Asym"+MOI,
#                 "MFT-22+%s+%s.og" % (s, dFreq) ])))
#plotBoth(243, mftFreqs, [(0,1,"Same drug loci"), (0,2, "Major loci"), (0,3,"First major, second minor")])

mftFreqs, maxHaplo = readFreqs(open(
    os.sep.join([projDir,
                 "2MFTDGF"+MOI,
                 "MFT-22+%s+%s.og" % (s, dFreq) ])))
plotBoth(243, mftFreqs, [(0,1,"Same drug"), (0,2, "Different drug")], "MFT, DGF", False)



#rotFreqs, maxHaplo = readFreqs(open(
#    os.sep.join([projDir,
#                 "2RotFull+Asym"+MOI,
#                 "ThresRot-22+%s+%s.og" % (s, dFreq) ])))
#plotBoth(244, rotFreqs, [(0,1,"Same drug loci"), (0,2, "Major loci"), (0,3,"First major, second minor")])

rotFreqs, maxHaplo = readFreqs(open(
    os.sep.join([projDir,
                 "2RotDGF"+MOI,
                 "ThresRot-22+%s+%s.og" % (s, dFreq) ])))
plotBoth(244, rotFreqs, [(0,1,"Same drug"), (0,2, "Different drug")], "Rotation, DGF", False)

pylab.show()
