from pylab import *
from sys import argv, exit
from os import listdir, sep

if len(argv)!=6:
    print "parameters: <projDir> <chart> <S> <dfreq> <scenario>"
    exit(-1)

projDir = argv[1]
fname = argv[2]
s = argv[3]
dFreq = argv[4]
scenario = argv[5]

sp = s[0]+'.'+s[1:]
dfp = dFreq[0]+'.'+dFreq[1:]

files = listdir(projDir+sep+scenario)
myFile = filter(lambda x: x.find(s + '+' + dFreq + '.og') > 1, files)[0]



f = open(sep.join([projDir, scenario, myFile]))
l = f.readline()
gen = -1
haplos = {}
while l != "":
    toks = l.rstrip().split(" ")
    hpl, freq = int(toks[0]), float(toks[1])
    if hpl==0: gen+=1
    haplos.setdefault(hpl,[]).append(freq)
    l = f.readline()

ncolors = len(haplos.keys()) + 0.0

for hpl in haplos:
    c = (int(hpl))/ncolors
    plot(haplos[hpl], color=(c,0,0), label=hpl)

axes().set_xlabel("Generations")
axes().set_ylabel("Frequency")

figtext(.5,.93,
    "Frequency of haplotypes over generations",
    ha="center")
figtext(.5,.9,
    "Black is fully sensitive, bright red multiple-resistant",
    ha="center")
show()

