import sys
import pylab
import os

if len(sys.argv) != 5:
    print "Arguments: %s <projDir> <s> <dFreq> <epi>" % (sys.argv[0])

projDir = sys.argv[1]
s = sys.argv[2]
dFreq = sys.argv[3]
epi = sys.argv[4]

sp = s[0]+'.'+s[1:]
dfp = dFreq[0]+'.'+dFreq[1:]


def readFreqs(f):
    l = f.readline()
    freqs = {}
    while l!="":
        hapl, freq = l.rstrip().split()
        hapl = int(hapl)
        freq = float(freq)
        freqs.setdefault(hapl, []).append(freq)
        l = f.readline()
    f.close()
    return freqs, max(freqs.keys())

fnameTpl = os.sep.join(["%s","2%s%s%d", "%s-22+%s+%s.og"])
pylab.axes().set_yscale('log')
for MOI in [2, 4]:
    for pol in [("Rot", "ThresRot"), ("MFT", "MFT")]:
        print MOI, pol
        fname = fnameTpl %(projDir, pol[0], epi, MOI, pol[1], s, dFreq)
        freqs, maxHaplo = readFreqs(open(fname))
        #pylab.plot(range(len(freqs[0])), freqs[0], label=str(MOI) + pol[0] + "S")
        pylab.plot(range(len(freqs[0])), freqs[maxHaplo], label=str(MOI) + pol[0])

pylab.legend()
pylab.show()
