from pylab import *
from copy import deepcopy
from sys import argv, exit

if len(argv) < 7:
    print "Parameters: <fname.ps> <isBW> <s> <dFreq> list of pairs <PolicyName,FileToRead>"
    exit(-1)

fname = argv[1]
isBW = argv[2].lower() in ["true", "t", "yes", "y", "1"]
s=argv[3]
dFreq=argv[4]
#print argv
myArg = deepcopy(argv[5:])
#print myArg
myArg.reverse()
caseList = []
if isBW:
    colors = ["-k","+-k","v-k","*-k"]
else:
    #TBD
    colors = ["","","",""]

fmts = {}
while len(myArg) > 0:
    polName = myArg.pop()
    fileName = myArg.pop()
    fmts[polName] = colors.pop()
    caseList.append((polName, fileName))

sp = s[0]+'.'+s[1]
dfp = dFreq[0]+'.'+dFreq[1]
suptitle('LD patterns for single drug models', fontsize=14)
title('fitness penalty='+sp+' and drug treatment rate='+dfp)
maxLength = 1000
myLDs={}
for case in caseList:
    polName, fileName = case
    f = open(fileName)
    l = f.readline()
    myLD = map(lambda x: float(x), l.rstrip().split(' '))
    if len(myLD) < maxLength: maxLength = len(myLD)
    myLDs[polName] = myLD
    f.close()
for polName, ld in myLDs.items():
    plot(ld[:(maxLength-1)], fmts[polName], label=polName)
axes().set_xlabel("Generation")
axes().set_ylabel("LD (r)")
legend()
#show()
savefig(fname)
