import sys
import pylab
import os
import re
from matplotlib.patches import Rectangle
from Utils import *

if len(sys.argv) != 6:
    print "Arguments: %s <projDir> <epi> <pol> <MOI> <cut>" % (sys.argv[0])
    sys.exit(-1)

projDir = sys.argv[1]
epi = sys.argv[2]
pol = sys.argv[3]
MOI = int(sys.argv[4])
cut = float(sys.argv[5])

myRe = re.compile(".*\+([0-9]+)\+([0-9]+)\.og$")

intersection = set()
cases = os.listdir(dirTpl(MOI) % (projDir, pol, epi, MOI))
for case in cases:
    match = myRe.match(case)
    if match:
        intersection.add((match.group(1), match.group(2)))


cases = []
plotCases = []
cnt = 0
for params in list(intersection):
    s = params[0]
    fastS = float(s[0]+"."+s[1:])
    if fastS>0.5: continue
    dFreq = params[1]
    #print s,dFreq

    if pol == "Rot":
        rotNameSw = fnameTplSw(MOI) %(projDir, "Rot", epi, MOI, "ThresRot", s, dFreq)
        sws = readSws(open(rotNameSw))
        if len(sws)>2:
            rotName = fnameTpl(MOI) %(projDir, "Rot", epi, MOI, "ThresRot", s, dFreq)
            rotFreqs, maxHaplo = readFreqs(open(rotName))
            s, dFreq = float(s[0]+"."+s[1:]), float(dFreq[0]+"."+dFreq[1:])
            gen = sws[2][0]
            if gen<10: continue
            mrfreq = rotFreqs[maxHaplo][gen]
            sensfreq = rotFreqs[0][gen]
            res = mrfreq/(1-sensfreq)
            #res = sensfreq
            cases.append(res)
            if res>0.95:
                print s, dFreq
            plotCases.append((dFreq,s,res))
    else:
        #MFT OR CT
        mftName = fnameTpl(MOI) %(projDir, pol, epi, MOI, pol, s, dFreq)
        mftFreqs, maxHaplo = readFreqs(open(mftName))
        g = getGen(mftFreqs, cut, epi)
        s, dFreq = float(s[0]+"."+s[1:]), float(dFreq[0]+"."+dFreq[1:])
        if g:
            if g<10:continue
            freq = 1 - (mftFreqs[maxHaplo][g] + mftFreqs[maxHaplo][g])
            mrfreq = mftFreqs[maxHaplo][g]
            sensfreq = mftFreqs[0][g]
            res = mrfreq/(1-sensfreq)
            #print s, dFreq, mrfreq, sensfreq
            #res = sensfreq
            if res>0.95:
                print s, dFreq
            cases.append(res)
            plotCases.append((dFreq,s,res))
    #print sws
    cnt += 1
    if cnt==3000: break


print pol, epi, MOI

pylab.hist(cases,20)
pylab.gca().set_xlim(0,1)
pylab.title("epi: %s, pol: %s, MOI: %f, cut: %f" % (epi, pol, MOI, cut))
pylab.legend()
pylab.show()
