import sys
import pylab
import os
import re
from matplotlib.patches import Rectangle

if len(sys.argv) != 5:
    print "Arguments: %s <projDir> <epi> <pol> <MOI>" % (sys.argv[0])
    sys.exit(-1)

projDir = sys.argv[1]
epi = sys.argv[2]
pol = sys.argv[3]
MOI = int(sys.argv[4])


def readFreqs(f):
    l = f.readline()
    freqs = {}
    while l!="":
        hapl, freq = l.rstrip().split(" ")
        hapl = int(hapl)
        freq = float(freq)
        freqs.setdefault(hapl, []).append(freq)
        l = f.readline()
    f.close()
    return freqs, max(freqs.keys())

dirTpl = os.sep.join(["%s","2%s%s%d"])
fnameTpl = os.sep.join([dirTpl, "%s-22+%s+%s.og"])
fnameTplSw = os.sep.join([dirTpl, "%s-22+%s+%s.sw"])

myRe = re.compile(".*\+([0-9]+)\+([0-9]+)\.og$")

intersection = set()

cases = os.listdir(dirTpl % (projDir, pol, epi, MOI))
for case in cases:
    match = myRe.match(case)
    if match:
        intersection.add((match.group(1), match.group(2)))

def readSws(f):
    sws = []
    l = f.readline()
    while l != "":
        sws.append(tuple(map(lambda x: int(x),l.rstrip().split(" "))))
        l = f.readline()
    f.close()
    return sws

def getGen(freqs, thres):
    for i in range(len(freqs[0])):
        if freqs[15][i]+freqs[3][i]+freqs[7][i]+freqs[11][i]+freqs[12][i]+freqs[13][i]+freqs[14][i]>thres*2:
            #print "X"
            #for i2 in range(16): print freqs[i2][i],
            #print
            return i
    return None

cases = []
plotCases = []
maxDur = 0
for params in list(intersection):
    s = params[0]
    dFreq = params[1]
    #print s,dFreq

    if pol == "Rot":
        rotNameSw = fnameTplSw %(projDir, "Rot", epi, 2, "ThresRot", s, dFreq)
        sws = readSws(open(rotNameSw))
        
        if len(sws)>2:
            maxDur = max(sws[2][0], maxDur)
            cases.append(sws[2][0])
            s, dFreq = float(s[0]+"."+s[1:]), float(dFreq[0]+"."+dFreq[1:])
            plotCases.append((dFreq,s,sws[2][0]))
    else:
        mftName = fnameTpl %(projDir, "MFT", epi, 2, "MFT", s, dFreq)
        mftFreqs, maxHaplo = readFreqs(open(mftName))
        g = getGen(mftFreqs, 0.1)
        #print s, dFreq, g
        s, dFreq = float(s[0]+"."+s[1:]), float(dFreq[0]+"."+dFreq[1:])
        #if s==0.3 and dFreq==0.4:
        #    sys.exit(-1)
        if g:
            maxDur =max(maxDur, g)
            cases.append(maxDur)
            plotCases.append((dFreq,s,g))

    #print sws


cnt = 0

for x,y,c in plotCases:
    #print x,y,c, posCase
    pylab.gca().add_patch(Rectangle((x,y), 0.01, 0.01, facecolor=(1.0*c/maxDur,0,0)))

    if cnt==3000: break

pylab.title("epi: %s, pol: %s, MOI: %d" % (epi, pol, MOI))
pylab.legend()
pylab.show()
