import sys
import pylab
import os
import re
from Utils import *
from matplotlib.patches import Rectangle

if len(sys.argv) != 7:
    print "Arguments: %s <projDir> <epi> <pol> <MOI> <numDrugs> <maxS>" % (sys.argv[0])
    sys.exit(-1)

projDir = sys.argv[1]
epi = sys.argv[2]
pol = sys.argv[3]
MOI = int(sys.argv[4])
numDrugs = int(sys.argv[5])
maxS = float(sys.argv[6])

myRe = re.compile(".*\+([0-9]+)\+([0-9]+)\.og$")

intersection = set()

cases = os.listdir(dirTpl(numDrugs) % (projDir, pol, epi, MOI))
for case in cases:
    match = myRe.match(case)
    if match:
        mS = match.group(1)
        matchS = float(mS[0]+"."+mS[1:])
        if matchS<maxS:
            intersection.add((match.group(1), match.group(2)))

sensitiveX = []
sensitiveY = []
MRX = []
MRY = []

cases = []
plotCases = []
maxDur = 0
for params in list(intersection):
    s = params[0]
    dFreq = params[1]
    #print s,dFreq

    if pol=="MFT":
        pre1 = "MFT"
        pre2 = "MFT"
    elif pol== "Rot":
        pre1 = "Rot"
        pre2 = "ThresRot"
    elif pol== "CT":
        pre1 = "CT"
        pre2 = "CT"
    name = fnameTpl(numDrugs) %(projDir, pre1, epi, MOI, pre2, s, dFreq)
    freqs, maxHaplo = readFreqs(open(name))
    s, dFreq = float(s[0]+"."+s[1:]), float(dFreq[0]+"."+dFreq[1:])
    if freqs[0][-1]>0.99:
        sensitiveX.append(dFreq)
        sensitiveY.append(s)
    if freqs[maxHaplo][-1]>0.99:
        MRX.append(dFreq)
        MRY.append(s)

    #print sws


print len(MRX), len(sensitiveX), len(intersection)
pylab.scatter(sensitiveX, sensitiveY, c="g", marker="s", s=60, label="Sensitive")
pylab.scatter(MRX, MRY, c="b", marker="s", s=60, label="MR")


pylab.title("epi: %s, pol: %s, MOI: %d" % (epi, pol, MOI))
pylab.legend()
pylab.show()
