import sys
import pylab
import os
import re
from matplotlib.patches import Rectangle

if len(sys.argv) != 4:
    print "Arguments: %s <projDir> <epi> <pol>" % (sys.argv[0])

projDir = sys.argv[1]
epi = sys.argv[2]
pol = sys.argv[3]



def readFreqs(f):
    l = f.readline()
    freqs = {}
    while l!="":
        hapl, freq = l.rstrip().split()
        hapl = int(hapl)
        freq = float(freq)
        freqs.setdefault(hapl, []).append(freq)
        l = f.readline()
    f.close()
    return freqs, max(freqs.keys())

dirTpl = os.sep.join(["%s","2%s%s%d"])
fnameTpl = os.sep.join([dirTpl, "%s-22+%s+%s.og"])
fnameTplSw = os.sep.join([dirTpl, "%s-22+%s+%s.sw"])

myRe = re.compile(".*\+([0-9]+)\+([0-9]+)\.og$")

p2 = set()
p4 = set()

for MOI in [2, 4]:
    if MOI==2:
        mySet = p2
    else:
        mySet = p4
    cases = os.listdir(dirTpl % (projDir, pol, epi, MOI))
    for case in cases:
        match = myRe.match(case)
        if match:
            mySet.add((match.group(1), match.group(2)))
intersection = p4.intersection(p2)

def readSws(f):
    sws = []
    l = f.readline()
    while l != "":
        sws.append(tuple(map(lambda x: int(x),l.rstrip().split(" "))))
        l = f.readline()
    f.close()
    return sws

def getGen(freqs, thres):
    for i in range(len(freqs[0])):
        if freqs[15][i]+freqs[3][i]+freqs[7][i]+freqs[11][i]+freqs[12][i]+freqs[13][i]+freqs[14][i]>thres*2:
            return i
    return None

cases = []
plotCases = []
for params in list(intersection):
    s = params[0]
    dFreq = params[1]
    #print s,dFreq

    if pol == "Rot":
        rotNameSw2 = fnameTplSw %(projDir, "Rot", epi, 2, "ThresRot", s, dFreq)
        sws2 = readSws(open(rotNameSw2))
        rotNameSw4 = fnameTplSw %(projDir, "Rot", epi, 4, "ThresRot", s, dFreq)
        sws4 = readSws(open(rotNameSw4))
        if len(sws2)>2 and len(sws4)>2:
            myCase = 1.0*sws2[2][0]/sws4[2][0]
            if myCase>0.5 and myCase<2: continue
            cases.append(myCase)
            s, dFreq = float(s[0]+"."+s[1:]), float(dFreq[0]+"."+dFreq[1:])
            plotCases.append((dFreq,s,myCase))
    else:
        mftName2 = fnameTpl %(projDir, "MFT", epi, 2, "MFT", s, dFreq)
        mftFreqs2, maxHaplo2 = readFreqs(open(mftName2))
        mftName4 = fnameTpl %(projDir, "MFT", epi, 4, "MFT", s, dFreq)
        mftFreqs4, maxHaplo4 = readFreqs(open(mftName4))
        g2 = getGen(mftFreqs2, 0.1)
        g4 = getGen(mftFreqs4, 0.1)
        s, dFreq = float(s[0]+"."+s[1:]), float(dFreq[0]+"."+dFreq[1:])
        if g4 and g2:
            myCase = 1.0*g2/g4
            if g2<10: continue
            #if myCase>0.5 and myCase<2: continue
            cases.append(myCase)
            plotCases.append((dFreq,s,myCase))
        else:
            plotCases.append((dFreq,s,None))
    #print sws


cases.sort()
posCase = cases[-1]
negCase = 1.0/cases[0]
print pol, epi, MOI, posCase, negCase

cnt = 0

for x,y,c in plotCases:
    #print x,y,c, posCase
    if not c:
        continue
        pylab.gca().add_patch(Rectangle((x,y), 0.01, 0.01, facecolor=(0,0,0)))
    elif c>1:
        pylab.gca().add_patch(Rectangle((x,y), 0.01, 0.01, facecolor=(c/posCase,0,0)))
    else:
        pylab.gca().add_patch(Rectangle((x,y), 0.01, 0.01, facecolor=(0,(1/c)/negCase,0)))
    cnt += 1
    if cnt==3000: break

pylab.title("epi: %s, pol: %s" % (epi, pol))
pylab.legend()
pylab.show()
