import sys
import pylab
import os
import re
from Utils import *

#2 or 3 drugs
#Not ART
#For 3 drugs only FullEpistasis (limitation in Utils)

if len(sys.argv) != 5:
    print "Arguments: %s <projDir> <epi> <MOI> <numDrugs>" % (sys.argv[0])
    sys.exit(-1)

projDir = sys.argv[1]
epi = sys.argv[2]
MOI = int(sys.argv[3])
numDrugs = int(sys.argv[4])


pMFT = set()
pRot = set()

myRe = re.compile(".*\+([0-9]+)\+([0-9]+)\.og$")
for pol in ["Rot", "MFT"]:
    if pol=="Rot":
        mySet = pRot
    else:
        mySet = pMFT
    cases = os.listdir(dirTpl(numDrugs) % (projDir, pol, epi, MOI))
    for case in cases:
        match = myRe.match(case)
        if match:
            mySet.add((match.group(1), match.group(2)))
intersection = pMFT.intersection(pRot)
print len(intersection)
rotWinX = []
rotWinY = []
mftWinX = []
mftWinY = []
cnt = 0
for params in intersection:
    s = params[0]
    dFreq = params[1]
    rotName = fnameTpl(numDrugs) % (projDir, "Rot", epi, MOI, "ThresRot", s, dFreq)
    rotNameSw = fnameTplSw(numDrugs) %(projDir, "Rot", epi, MOI, "ThresRot", s, dFreq)
    mftName = fnameTpl(numDrugs) %(projDir, "MFT", epi, MOI, "MFT", s, dFreq)
    rotFreqs, maxHaplo = readFreqs(open(rotName))
    mftFreqs, maxHaplo = readFreqs(open(mftName))
    sws = readSws(open(rotNameSw))
    #print sws
    
    s, dFreq = float(s[0]+"."+s[1:]), float(dFreq[0]+"."+dFreq[1:])
    #winner = getWinner(rotFreqs[0], mftFreqs[0])
    mftGen = getGen(mftFreqs, 0.1, epi, numDrugs)
    lensws = numDrugs
    if len(sws)<lensws and mftGen:
        winner = 1
    elif len(sws)>lensws and not mftGen:
        winner = 2
    if len(sws)>lensws and mftGen:
        #winner = getRotWinner(sws[2][0], rotFreqs, mftFreqs)
        #print sws[2][0],mftGen
        if sws[lensws][0]<mftGen:
            winner=2
        elif sws[lensws][0]>mftGen:
            winner =1
        else:
            winner = 0
    else:
        winner = 0
    if winner == 1:
        rotWinY.append(s)
        rotWinX.append(dFreq)
    elif winner == 2:
        mftWinY.append(s)
        mftWinX.append(dFreq)
    cnt += 1
    if cnt % 100 == 0: print cnt
    if cnt==2000: break
    #pylab.plot(range(len(freqs[0])), freqs[0], label=str(MOI) + pol[0] + "S")
    #pylab.plot(range(len(freqs[0])), freqs[maxHaplo], label=str(MOI) + pol[0])

if len(rotWinX) > 0:
    pylab.scatter(rotWinX, rotWinY, c="g", marker="s", s=60, label="Rotation")
if len(mftWinX) > 0:
    pylab.scatter(mftWinX, mftWinY, marker="s", s=60, label="MFT")
pylab.title("epi: %s, MOI: %d" % (epi, MOI))
pylab.legend()
#pylab.gca().set
pylab.gca().set_xlabel("Drug frequency")
pylab.gca().set_ylabel("Fitness penalty")
pylab.show()
