from pylab import *
from sys import argv, exit

if len(argv) != 4:
    print "Parameters: <fname.ps> <isBW> <maxFreq>"
    exit(-1)

fname = argv[1]
isBW = argv[2].lower() in ["true", "t", "yes", "y", "1"]
maxFreq = int(argv[3])

mois = [1, 2, 4, 8, 10]
xs = map(lambda x: x/1000.0, range(maxFreq))

def doBinom(point, moi):
    return 1-(1-point)**moi

for moi in mois:
    ys = map(lambda x: doBinom(x,moi), xs)
    if isBW:
        plot(xs, ys, label="MOI " + str(moi), color=(moi/12.0, moi/12.0, moi/12.0))
    else:
        plot(xs, ys, label=str(moi))
axes().set_ylabel("Prevalence")
axes().set_xlabel("Frequency")
title("Relationship between prevalence and frequency of resistance")

legend(loc=4)
savefig(fname)
