from copy import deepcopy

def createTableRec():
    tableRec={}
    for i1 in range(totalClones):
        for i2 in range(totalClones):
            diffs = i1 ^ i2
            basis = (i1 | i2) ^ diffs
            values = []
            values.append(basis)
            divDiffs = diffs
            divPos = 0
            while divDiffs >0:
                if divDiffs % 2 == 1:
                    dbl = deepcopy(values)
                    for value in dbl:
                        values.append(value + 2**divPos)
                divPos += 1
                divDiffs /= 2
            valuesArr = [0]*len(values)
            for i in range(len(valuesArr)):
                valuesArr[i] = values[i];
            tableRec[i1*totalClones + i2] = valuesArr
    return tableRec


def calcNumMuts(clone):
   numMuts = 0
   while clone>0:
       numMuts += clone % 2
       clone /= 2
   return numMuts

def calcRealS(clones):
    res = []
    div = 0.0
    for clone in clones:
        div += (1-s)**calcNumMuts(clone)
    for ci in range(len(clones)):
        res.append((1-s)**calcNumMuts(clones[ci])/div)
    return res

def recombine(clones):
    clFreq = [0.0]*totalClones
    clFit = calcRealS(clones)
    for c1 in range(len(clFit)):
        for c2 in range(len(clFit)):
            sharedFit = clFit[c1] * clFit[c2];
            newClones = tableRec[clones[c1]*totalClones + clones[c2]]
            for clone in newClones:
                clFreq[clone] += sharedFit / len(newClones);
    return clFreq

totalClones=4
s=0.1

tableRec = createTableRec()
print tableRec
print recombine([0,1,2,3])
