from pylab import *
from sys import argv, exit

if len(argv) != 3:
    print "Parameters: <fname> <isBW>"
    exit(-1)

fname = argv[1]
isBW = argv[2].lower() in ["true", "t", "yes", "y", "1"]




def getInfFreq(cm, f, Dl, fullEpi):
    if Dl>0:
        D = Dl*f*(1-f)
    else:
        if f<0.5:
            D = Dl*f**2
        else:
            D = Dl*(1-f)**2
    #print "D", D,
    if fullEpi:
        res = f**2 + D
    else:
        res = f**2 + D
        res += f*(1-f) - D
        res += (1-f)*f - D
    #print "res", res, 
    return 1.0 - (1.0-res)**cm

Dls = [-1.0, -0.5, 0.0, 0.5, 1.0]
Dls = [-0.5, 0.0, 0.5]
Dls = [0.0, 0.5]
def getExpansion(cm):
    full = {}
    none = {}
    for Dl in Dls:
        full[Dl]=[]
        none[Dl]=[]
        #print "*****", Dl
        for f in range(1,100):
            full[Dl].append(getInfFreq(cm, f/100.0, Dl, True))
            none[Dl].append(getInfFreq(cm, f/100.0, Dl, False))
    return full, none

x = map(lambda x: x/100.0, range(1,100))
for Dl in Dls:
    for cm in [1,2,4]:
        full, none = getExpansion(cm)
        if isBW:
            if cm == 1:
                c = 'k'
            elif cm == 2:
                c = 'k.'
            else:
                c = 'k+'
        else:
            if cm == 1:
                c = 'r'
            elif cm == 2:
                c = 'g'
            else:
                c = 'b'
        myFull = []
        myNone = []
        for ix in range(len(x)):
            myFull.append(full[Dl][ix]/x[ix])
            myNone.append(none[Dl][ix]/x[ix])
        myFull = full[Dl]
        if Dl == 0.0: point = '-'
        else: point = ':'
        plot(x, myFull, c+point, label='MOI ' + str(cm) + ", r " + str(Dl))
        #plot(x, myNone, c+'.', label='MOI ' + str(cm) + ', DGF')
        if cm==1:
            cm1 = full[Dl]
            cm1dgf = none[Dl]
        elif cm==4:
            cm4 = full[Dl]
            cm4dgf = none[Dl]
        #plot(x,x,'k', linewidth=0.1)
title('The impact of frequency and LD on prevalence')
ylabel('Prevalence')
xlabel('Frequency of the resistant allele')
legend(loc=4)
#axes().set_xscale('log')
#axes().set_yscale('log')
savefig(fname)
#plot(x, none[Dl], c+'.',label='none ' + str(cm) + ' ' + str(Dl))

#legend()

exit(-1) 
dgf = []
full = []
for i in range(99):
    dgf.append(cm4dgf[i]/cm1dgf[i])
    full.append(cm4[i]/cm1[i])

cla()
plot(x, dgf, label = 'dgf')
plot(x, full, label = 'full')
legend()
