from pylab import *
from sys import argv, exit

if len(argv) != 5:
    print "Parameters: <fname> <isBW> <s> <dFreq>"
    exit (-1)

fname = argv[1]
isBW = argv[2].lower() in ["true", "t", "yes", "y", "1"]


s = argv[3]
dFreq = argv[4]
cms = ['2', '3', '4']
if isBW:
    colors = {'21':'r', '2':'k-', '3':'k-.', '4':'k--'}
else:
    colors = {'21':'r', '2':'g', '3':'y', '4':'b'}

sp = s[0]+'.'+s[1]
dfp = dFreq[0]+'.'+dFreq[1:]
suptitle('Change in frequency of sensitive haplotypes ', fontsize=14)
title('fitness penalty='+sp+' and drug treatment rate='+dfp)

def getFreqs(f):
    l = f.readline()
    while l != '':
        toks = l.rstrip().split(' ')
        haplo = toks[0]
        if haplo == "S":
            s = map(lambda x: float(x), toks[1:])
            return s
        l = f.readline()

for cm in cms:
    f = open('down/full-cm' + cm + '/freqsMFT-12-' + cm + '+' + s + '+' + dFreq + '.txt')
    #print('down/full-cm' + cm + '/freqsMFT-12-' + cm + '+' + s + '+' + dFreq + '.txt')
    sensFreq = getFreqs(f)
    f.close()
    effectiveSofSens = []
    startFreq = sensFreq[0]
    for freq in sensFreq[1:]:
        effectiveSofSens.append(freq/startFreq)
        startFreq = freq
    plot(sensFreq[:-1], effectiveSofSens, colors[cm], label = "MOI " + cm)
axes().set_ylabel('Frequency change')
axes().set_xlabel('Sensitive frequency')
legend()
savefig(fname)


