from pylab import *
from sys import argv, exit
from os import listdir, sep

if len(argv) != 7:
    print "Parameters: <projdir> <figure> <isBW> <s> <dFreq> <epistasis>"
    exit (-1)

projDir=argv[1]
fname = argv[2]
isBW = argv[3].lower() in ["true", "t", "yes", "y", "1"]

s = argv[4]
dFreq = argv[5]
cms = ['1', '2', '4']
if isBW:
    colors = {'1':'k', '2':'k.', '4':'k+'}
else:
    colors = {'1':'r', '2':'g', '4':'b'}


epi = argv[6]


sp = s[0]+'.'+s[1:]
dfp = dFreq[0]+'.'+dFreq[1:]
suptitle('Frequency and increase rate of sensitive parasites', fontsize=14)
title('fitness penalty='+sp+' and drug rate='+dfp)
maxLength = 1000
resultsSpeed = {}
resultsFreq = {}
for cm in cms:
    files = listdir(projDir+sep+epi+cm)
    myFile = filter(lambda x: x.startswith('MFT') and x.find('12+' + s + '+' + dFreq + '.og') > 1, files)[0]

    #print epi+'cm' + cm + '/' + myFile
    f = open(projDir + sep + epi + cm + sep + myFile)
    l = f.readline()
    allFreqs = []
    while l<>'':
        toks = l.rstrip().split(' ')
        haplo = toks[0]
        #if haplo == "SS" or haplo == "S":
        if haplo == "0":
            freqGen = {}
            currFreq = float(toks[1])
            allFreqs.append(currFreq)
        l = f.readline()
    speed = []
    currFreq = allFreqs[0]
    for freq in allFreqs[1:]:
        speed.append(freq/currFreq)
        currFreq = freq
    resultsSpeed['MOI ' + cm] = colors[cm]+ '-', speed
    resultsFreq['MOI ' + cm] = colors[cm] + '-.', allFreqs
    if len(allFreqs)< maxLength: maxLength = len(allFreqs)


    f.close()
mois = resultsSpeed.keys()
mois.sort()
for moi in mois:
    cl,lst = resultsSpeed[moi]
    plot(lst[:(maxLength-1)], cl, label = moi + " rate")
    cl,lst = resultsFreq[moi]
    plot(lst[:(maxLength-1)], cl, label = moi + " frequency")
#for lgd,(cl, lst) in resultsSpeed.items():
#    plot(lst[:(maxLength-1)], cl, label = lgd + " rate")
#for lgd,(cl, lst) in resultsFreq.items():
#    plot(lst[:(maxLength-1)], cl, label = lgd + " frequency")
axes().set_xlabel('Generations')
axes().set_ylabel('Frequency/Rate')
legend(loc=4)
savefig(fname)


