from pylab import *
from sys import argv, exit

if len(argv) != 3:
    print "Parameters: <s> <dFreq>"
    exit (-1)

s = argv[1]
dFreq = argv[2]
cms = ['1', '2', '4']
colors = {'1':'r', '2':'g', '4':'b'}

sp = s[0]+'.'+s[1:]
dfp = dFreq[0]+'.'+dFreq[1:]
suptitle('Speed of change', fontsize=14)
title('fitness penalty='+sp+' and drug frequency='+dfp)

def getSpeedFreq(f, strain):
    l = f.readline()
    while l<>'':
        toks = l.rstrip().split(' ')
        haplo = toks[0]
        if haplo == strain:
            freqGen = {}
            currFreq = float(toks[1])
            allFreqs = [currFreq]
            speed = []
            freqs = map(lambda x: float(x), toks[2:])
            allFreqs.extend(freqs)
            for freq in freqs:
                speed.append(freq/currFreq)
                currFreq = freq
        l = f.readline()
    return speed, allFreqs

maxLength = 1000
results = {}
for cm in cms:
    f = open('cm' + cm + '/freqsMFT-21-' + cm + '+' + s + '+' + dFreq + '.txt')
    speed, allFreqs = getSpeedFreq(f, 'RR')
    #plot(speed, colors[cm], label='MFT speed ' + cm)
    results['MFT speed ' + cm] = colors[cm], speed
    plot(allFreqs, colors[cm]+'.' , label='MFT freq ' + cm)
    f.close()
    f = open('cm' + cm + '/freqsThresRot-21-' + cm + '+' + s + '+' + dFreq + '.txt')
    speed, allFreqs = getSpeedFreq(f, 'RR')
    #plot(speed, colors[cm] + ',', label='Rot speed ' + cm)
    results['Root speed ' + cm] = colors[cm], speed
    plot(allFreqs, colors[cm]+'^' , label='Rot freq ' + cm)

#axes().set_yscale('log')
axes().set_ylabel('Generations')
axes().set_xlabel('Drop in sensitive frequency')
legend()
show()


