from os import listdir
from sys import argv, exit

datadir = argv[1]


cases = {
        'singlelocus' : '11-cm',
#        'full' : 'epi/single-full-cm',
#        'none' : 'epi/single-none-cm',
#        'assym + full' : 'epi/real-cm',
#        'none + full' : 'epi/mixed-cm',
#        '2 assym + full' : 'epi/double-real-cm'
        }

def isStable(fName):
    f = open(fName)
    sens = map(lambda x:float(x), f.readline().split(' '))
    f.close()
    if len(sens)<41: return False
    #checking the distance below 1% after 20 generations
    start = sens[40]
    gen = 70
    while gen<len(sens):
        current = sens[gen]
        if start>0.05 and start<0.95 and abs(start - current) < 0.01: return True
        start = current
        gen += 30
    return False

for case in cases:
    dire = datadir + '/' + cases[case]
    print case,
    for cm in ['1', '2', '4']:
        dircm = dire+cm
        allfiles = listdir(dircm)
        freqfiles = filter(lambda x: x.startswith('allfreqsMFT'), allfiles)
        stability = map( lambda x: isStable(dircm+'/'+x), freqfiles)
        stableCases = filter(lambda x:x==True, stability)
        print 1.0*len(stableCases)/len(stability),
    print
